########################
#  ONI TEAM ARENA 1.2  #
#  Lab                 #
########################
################ FRAMES SINCE LAST RESTART
var int arena_time= 0;
################ RANDOM VARIABLES (CORE)
var int rand_cell= 0; var int rand_ammo= 0;
var int rand_invis= 0; var int rand_shield= 0;
var int rand_dead= 0; var int rand_weapon= 0;
var int rand_flag1= 0; var int rand_flag2= 0;
var int rand_music= 0;
################ THEIR MAX VALUES (CUSTOM)
######## POWERUPS, WEAPONS AND DEATH MESSAGES (LEVEL-INDEPENDENT)
var int rand_cell_max= 6; var int rand_ammo_max= 7;
var int rand_invis_max= 98; var int rand_shield_max= 99;
var int rand_dead_max= 22; var int rand_weapon_max= 14;
######## TELEPORT FLAG (LEVEL- AND AREA-DEPENDENT)
var int rand_flag1_max= 10; var int rand_flag2_max= 11;
######## MUSIC (LEVEL-DEPENDENT)
var int rand_music_max= 1;
################ AUXILIARY VARIABLES (CORE)
var string now_playing; var string next_tune;
var string rand_weapon_name;
###################################################################
################ JUKEBOX (CORE)
func void ArenaMusic(void) {
	if(next_tune ne now_playing) {
		sound_music_stop(now_playing); now_playing= next_tune; 
		sleep 400; sound_music_start(now_playing);
	}
	sleep 4000; fork ArenaMusic();
}
################ RANDOMIZER INITIALIZATION (CUSTOM, AREA-SPECIFIC)
func void RandInit(void) {
	rand_cell_max= 6; rand_shield_max= 99;
	rand_ammo_max= 7; rand_invis_max= 98;
	rand_dead_max= 22; rand_weapon_max= 14;
	rand_music_max= 3; ArenaResetFlags();

	now_playing= atm_gr06; next_tune= mus_fitec_hd;
	rand_weapon_name= w6_vdg;
	fork RandGen();
}
func ArenaResetFlags {
	if(arena_area eq 0) {rand_flag1_max= 6; rand_flag2_max= 7;}
	if(arena_area eq 1) {rand_flag1_max= 13; rand_flag2_max= 14;}
	if(arena_area eq 2) {rand_flag1_max= 5; rand_flag2_max= 6;}
	if(arena_area eq 3) {rand_flag1_max= 11; rand_flag2_max= 12;}
	if(arena_area eq 4) {rand_flag1_max= 3; rand_flag2_max= 4;}
	if(arena_area eq 5) {rand_flag1_max= 1; rand_flag2_max= 2;}
}
################ RANDOM NUMBER GENERATOR (CORE)
func void RandGen(void) {
	rand_cell= rand_cell + 1; if(rand_cell > rand_cell_max) rand_cell= 0;
	rand_ammo= rand_ammo + 1; if(rand_ammo > rand_ammo_max) rand_ammo= 0;
	rand_invis= rand_invis + 1; if(rand_invis > rand_invis_max) rand_invis= 0;
	rand_shield= rand_shield + 1; if(rand_shield > rand_shield_max) rand_shield= 0;
	rand_dead= rand_dead + 1; if(rand_dead > rand_dead_max) rand_dead= 0;
	rand_weapon= rand_weapon + 1; if(rand_weapon > rand_weapon_max) rand_weapon= 0
	rand_flag1= rand_flag1 + 1; if(rand_flag1 > rand_flag1_max) rand_flag1= 0;
	rand_flag2= rand_flag2 + 1; if(rand_flag2 > rand_flag2_max) rand_flag2= 0;
	rand_music= rand_music + 1; if(rand_music > rand_music_max) rand_music= 0;

	arena_time= arena_time + 1;
	if(arena_limit eq 1 and arena_time eq 9600) sound_ambient_start alarm_loop
	if(arena_limit eq 2 and arena_time eq 16800) sound_ambient_start alarm_loop
	sleep 1; fork RandGen();
}
################ CLIENT FUNCTIONS (CUSTOM)
######## POWERUPS (LEVEL-INDEPENDENT)
func void GiveRandPowerups(string ai_name) {
	if(rand_shield > 95) chr_givepowerup(ai_name, shield);
	if(rand_invis  > 95) chr_givepowerup(ai_name, invis);
	chr_givepowerup(ai_name, cell, rand_cell);
	chr_givepowerup(ai_name, ammo, rand_ammo);
}
######## MUSIC FILES (LEVEL-DEPENDENT)
func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_main01;
	if(rand_music eq 1) next_tune= mus_main03;
}
######## WEAPONS (LEVEL-INDEPENDENT)
func void RandWeapon(void) {
	if(rand_weapon eq  0) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  1) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  2) rand_weapon_name=  w7_scc;
	if(rand_weapon eq  3) rand_weapon_name=  w1_tap;
	if(rand_weapon eq  4) rand_weapon_name=  w2_sap;
	if(rand_weapon eq  5) rand_weapon_name=  w3_phr;
	if(rand_weapon eq  6) rand_weapon_name=  w4_psm;
	if(rand_weapon eq  7) rand_weapon_name=  w5_sbg;
	if(rand_weapon eq  8) rand_weapon_name=  w6_vdg;
	if(rand_weapon eq  9) rand_weapon_name=  w7_scc;
	if(rand_weapon eq 10) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 11) rand_weapon_name=  w9_scr;
	if(rand_weapon eq 12) rand_weapon_name=  w8_mbo;
	if(rand_weapon eq 13) rand_weapon_name= w11_ba1;
	if(rand_weapon eq 14) rand_weapon_name=  w4_psm;
}
######## TELEPORT FLAGS (LEVEL- AND AREA-DEPENDENT)
func void SendToRandFlag(int ai_id, string ai_name, string ai_team) {
	if(ai_team ne Konoko and ai_team ne Syndicate) {
		if(rand_flag1 > rand_flag2) ai_team= Konoko
		else                     ai_team= Syndicate
	}
################ COURTYARD
	if(arena_area eq 0) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 200); chr_facetoflag(ai_name, 200);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 104); chr_facetoflag(ai_name, 104);}
			if(rand_flag1 > 1)
				{chr_teleport(ai_name, 7000); chr_facetoflag(ai_name, 7000);}
			
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name, 115); chr_facetoflag(ai_name, 115);}
			if(rand_flag2 eq  1)
				{chr_teleport(ai_name, 100); chr_facetoflag(ai_name, 100);}
			if(rand_flag2 >  1)
				{chr_teleport(ai_name, 114); chr_facetoflag(ai_name, 114);}
			
		}
	}
################ VAGO BIOTECH
	if(arena_area eq 1) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 90); chr_facetoflag(ai_name, 90);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 91); chr_facetoflag(ai_name, 91);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 92); chr_facetoflag(ai_name, 92);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 93); chr_facetoflag(ai_name, 93);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 94); chr_facetoflag(ai_name, 94);}
			if(rand_flag1 eq 5)
				{chr_teleport(ai_name, 95); chr_facetoflag(ai_name, 95);}
			if(rand_flag1 eq 6)
				{chr_teleport(ai_name, 96); chr_facetoflag(ai_name, 96);}
			if(rand_flag1 eq 7)
				{chr_teleport(ai_name, 97); chr_facetoflag(ai_name, 97);}
			if(rand_flag1 eq 8)
				{chr_teleport(ai_name, 255); chr_facetoflag(ai_name, 255);}
			if(rand_flag1 eq 9)
				{chr_teleport(ai_name, 305); chr_facetoflag(ai_name, 305);}
			if(rand_flag1 eq 10)
				{chr_teleport(ai_name, 306); chr_facetoflag(ai_name, 306);}
			if(rand_flag1 eq 11)
				{chr_teleport(ai_name, 107); chr_facetoflag(ai_name, 107);}
			if(rand_flag1 eq 12)
				{chr_teleport(ai_name, 108); chr_facetoflag(ai_name, 108);}
			if(rand_flag1 >  12)
				{chr_teleport(ai_name, 109); chr_facetoflag(ai_name, 109);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name, 123); chr_facetoflag(ai_name, 123);}
			if(rand_flag2 eq  1)
				{chr_teleport(ai_name, 124); chr_facetoflag(ai_name, 124);}
			if(rand_flag2 eq  2)
				{chr_teleport(ai_name, 132); chr_facetoflag(ai_name, 132);}
			if(rand_flag2 eq  3)
				{chr_teleport(ai_name, 133); chr_facetoflag(ai_name, 133);}
			if(rand_flag2 eq  4)
				{chr_teleport(ai_name, 138); chr_facetoflag(ai_name, 138);}
			if(rand_flag2 eq  5)
				{chr_teleport(ai_name, 140); chr_facetoflag(ai_name, 140);}
			if(rand_flag2 eq  6)
				{chr_teleport(ai_name, 211); chr_facetoflag(ai_name, 211);}
			if(rand_flag2 eq  7)
				{chr_teleport(ai_name, 212); chr_facetoflag(ai_name, 212);}
			if(rand_flag2 eq  8)
				{chr_teleport(ai_name, 213); chr_facetoflag(ai_name, 213);}
			if(rand_flag2 eq  9)
				{chr_teleport(ai_name, 214); chr_facetoflag(ai_name, 214);}
			if(rand_flag2 eq 10)
				{chr_teleport(ai_name, 215); chr_facetoflag(ai_name, 215);}
			if(rand_flag2 eq 11)
				{chr_teleport(ai_name, 216); chr_facetoflag(ai_name, 216);}
			if(rand_flag2 eq 12)
				{chr_teleport(ai_name, 243); chr_facetoflag(ai_name, 243);}
			if(rand_flag2 >  12)
				{chr_teleport(ai_name, 244); chr_facetoflag(ai_name, 244);}
		}
	}
################ THE DAY AFTER
	if(arena_area eq 2) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 7010); chr_facetoflag(ai_name, 7010);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 7011); chr_facetoflag(ai_name, 7011);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 7012); chr_facetoflag(ai_name, 7012);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 7013); chr_facetoflag(ai_name, 7013);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 7014); chr_facetoflag(ai_name, 1136);}
			if(rand_flag1 >  4)
				{chr_teleport(ai_name, 7015); chr_facetoflag(ai_name, 7015);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name, 7016); chr_facetoflag(ai_name, 7016);}
			if(rand_flag2 eq  1)
				{chr_teleport(ai_name, 7017); chr_facetoflag(ai_name, 7017);}
			if(rand_flag2 eq  2)
				{chr_teleport(ai_name, 7018); chr_facetoflag(ai_name, 7018);}
			if(rand_flag2 eq  3)
				{chr_teleport(ai_name, 7020); chr_facetoflag(ai_name, 7020);}
			if(rand_flag2 eq  4)
				{chr_teleport(ai_name, 7021); chr_facetoflag(ai_name, 7021);}
			if(rand_flag2 eq  5)
				{chr_teleport(ai_name, 7022); chr_facetoflag(ai_name, 7022);}
			if(rand_flag2 >   5)
				{chr_teleport(ai_name, 7023); chr_facetoflag(ai_name, 7023);}
		}
	}
################ NEPTUNE'S KITCHEN
	if(arena_area eq 3) {
		if(ai_team eq Konoko) {
			if(rand_flag1 eq 0)
				{chr_facetoflag(ai_name, 113); chr_teleport(ai_name, 113);}
			if(rand_flag1 eq 1)
				{chr_facetoflag(ai_name, 142); chr_teleport(ai_name, 142);}
			if(rand_flag1 eq 2)
				{chr_facetoflag(ai_name, 209); chr_teleport(ai_name, 209);}
			if(rand_flag1 eq 3)
				{chr_facetoflag(ai_name, 217); chr_teleport(ai_name, 217);}
			if(rand_flag1 eq 4)
				{chr_facetoflag(ai_name, 218); chr_teleport(ai_name, 218);}
			if(rand_flag1 eq 5)
				{chr_facetoflag(ai_name, 219); chr_teleport(ai_name, 219);}
			if(rand_flag1 eq 6)
				{chr_facetoflag(ai_name, 220); chr_teleport(ai_name, 220);}
			if(rand_flag1 eq 7)
				{chr_facetoflag(ai_name, 221); chr_teleport(ai_name, 221);}
			if(rand_flag1 eq 8)
				{chr_facetoflag(ai_name, 222); chr_teleport(ai_name, 222);}
			if(rand_flag1 eq 9)
				{chr_facetoflag(ai_name, 223); chr_teleport(ai_name, 223);}
			if(rand_flag1 >  9)
				{chr_facetoflag(ai_name, 224); chr_teleport(ai_name, 224);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq 0)
				{chr_facetoflag(ai_name, 225); chr_teleport(ai_name, 225);}
			if(rand_flag2 eq 1)
				{chr_facetoflag(ai_name, 226); chr_teleport(ai_name, 226);}
			if(rand_flag2 eq 2)
				{chr_facetoflag(ai_name, 227); chr_teleport(ai_name, 227);}
			if(rand_flag2 eq 3)
				{chr_facetoflag(ai_name, 228); chr_teleport(ai_name, 228);}
			if(rand_flag2 eq 4)
				{chr_facetoflag(ai_name, 229); chr_teleport(ai_name, 229);}
			if(rand_flag2 eq 5)
				{chr_facetoflag(ai_name, 230); chr_teleport(ai_name, 230);}
			if(rand_flag2 eq 6)
				{chr_facetoflag(ai_name, 231); chr_teleport(ai_name, 231);}
			if(rand_flag2 eq 7)
				{chr_facetoflag(ai_name, 232); chr_teleport(ai_name, 232);}
			if(rand_flag2 eq 8)
				{chr_facetoflag(ai_name, 233); chr_teleport(ai_name, 233);}
			if(rand_flag2 eq 9)
				{chr_facetoflag(ai_name, 234); chr_teleport(ai_name, 234);}
			if(rand_flag2 eq 10)
				{chr_facetoflag(ai_name, 235); chr_teleport(ai_name, 235);}
			if(rand_flag2 >  10)
				{chr_facetoflag(ai_name, 236); chr_teleport(ai_name, 236);}
		}
	}
################ HEAVEN ELEVEN
	chr_animate(ai_name, KONCOMsuper_kick);
}
######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "is dead"
}
